/*
 * File: CALOSidebar.java
 * 
 * Contains class CALOSidebar
 * 
 * Author: Brian Ellis
 */

package edu.cmu.hcii.calo;

import javax.swing.UIManager;

import edu.cmu.hcii.calo.engine.XMLScriptParser;

/**
 * A main class that invokes the CALO sidebar with an automated engine.
 * 
 * @author Brian Ellis
 * 
 */
public class CALOSidebar {

	/**
	 * The main function for the CALO sidebar.
	 * 
	 * @param args command-line arguments (unused)
	 */
	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {
			System.err.println("Error setting native LAF: " + e);
		}

		final SidebarWindow sidebar = new SidebarWindow(false);
		sidebar.setVisible(true);
		new XMLScriptParser();
	}
}
