/* File: WizardOfOzEngineException.java
 *
 * Contains class WizardOfOzEngineException
 *
 * Author: Will Haines
 */

package edu.cmu.hcii.calo.engine;

/**
 * An exception to be thrown when the Wizard of Oz engine fails to process a request from the front
 * end.
 * 
 * @author Will Haines
 */
public class WizardOfOzEngineException extends RuntimeException {

	/** Prevent serialization collisions. */
	private static final long serialVersionUID = 87761351967318726L;

	/**
	 * Create an engine exception with a defined error message.
	 * 
	 * @param string the error message
	 */
	public WizardOfOzEngineException(String string) {
		super(string);
	}

}
