/* File: PrioritizedObject.java
 *
 * Contains class PrioritizedObject
 *
 * Author: Brian Ellis
 */

package edu.cmu.hcii.calo.model;

/**
 * Represents a ManagedObject that has a priority value associated with it.
 * 
 * @author Brian Ellis
 * 
 */
public abstract class PrioritizedObject extends ManagedObject {

	/**
	 * Gets the priority associated with this PrioritizedObject.
	 * 
	 * @return the priority
	 */
	public abstract double getPriority();

}
