/* File: SidebarPropertyNames.java
 *
 * Contains class SidebarPropertyNames
 *
 * Author: Will Haines
 */

package edu.cmu.hcii.calo.support;

/**
 * The property names that are defined for PropertyChangeEvents emanating from the panes in the
 * sidebar.
 * 
 * @author Will Haines
 * 
 */
public class SidebarPropertyNames {

	/**
	 * Fired whenever a pane changes size. The old and new values will be the old and new
	 * dimensions.
	 */
	public static final String PANE_RESIZED = "PaneResized";

	/**
	 * Fired whenever a pane is expanded or collapsed. The old and new value will be the value of
	 * isExpanded.
	 */
	public static final String PANE_EXPANDED = "PaneExpanded";
}
