package edu.cmu.hcii.calo.util;

import java.util.StringTokenizer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Executes URLs, links, commands, file paths, etc.
 * 
 * This class is only partly documented because I didn't write it and have only an inkling about how
 * it works. It was released into the public domain by the author in a forum post, but without much
 * documentation.
 * 
 * Also, it uses Hungarian variable naming, which makes me want to stick a pickaxe through my head.
 * 
 * @author kvally74, whoever that is
 */

public class CommandLauncher {

	private static Pattern pUrlPattern =
		Pattern.compile("^www\\.|^http:|^mailto:|^file:|^WWW\\.|^HTTP:|^MAILTO:|^FILE:");

	private static Pattern pServerSharePatern = Pattern.compile("^[\\\\//]");
	private static Pattern pFilePattern = Pattern.compile("^[A-Za-z\\\\//][:]");

	/**
	 * Executes the command passed. Will launch applications, documents, and Web sites, among other
	 * things.
	 * 
	 * @param sCommand the command to execute
	 */
	public static void exec(String sCommand) {
		try {
			Runtime.getRuntime().exec("cmd /c start " + CommandLauncher.getCompletePath(sCommand));
		} catch (Exception _exception) {
			_exception.printStackTrace();
		}
	}

	/** Gives the full path to execute */
	private static String getCompletePath(String sCommand) {

		String sCompletePath = "";
		boolean bContinue = false;

		/* I am using StringTokenizer class, my be over ride with Pattern ? */
		StringTokenizer st1 = new StringTokenizer(sCommand, " ", true);

		for (int i = 0; st1.hasMoreTokens(); i++ ) {
			String sToken = st1.nextToken();

			if (CommandLauncher.isPossibleURL(sToken)) {
				bContinue = true;
				sCompletePath = sCompletePath + " " + sToken;
			} else if (CommandLauncher.isPossibleFile(sToken)) {
				bContinue = true;
				sCompletePath = sCompletePath + " file:/" + sToken;
			} else if (CommandLauncher.isPossibleServerShare(sToken)) {
				bContinue = true;
				sCompletePath = sCompletePath + " file:" + sToken;
			} else if (sToken.equals(" ")) {
				if (bContinue) {
					sCompletePath = sCompletePath + "%20";
				} else {
					sCompletePath = sCompletePath + " " + sToken;
				}
			} else {
				sCompletePath = sCompletePath + sToken;
			}
		}
		return sCompletePath.trim();
	}

	/** Checks whether the url starts with c: or similar */
	private static boolean isPossibleFile(String sFile) {

		Matcher filematcher = CommandLauncher.pFilePattern.matcher(sFile);
		if (filematcher.find()) {
			return true;
		}
		return false;
	}

	/** Checks whether the url starts with server share like //server/dir* */
	private static boolean isPossibleServerShare(String sCmd) {

		Matcher serversharematcher = CommandLauncher.pServerSharePatern.matcher(sCmd);
		if (serversharematcher.find()) {
			return true;
		}
		return false;
	}

	/**
	 * Checks whether the url starts with www. or mailto: or http: or ....
	 * 
	 * @param sUrl the url to check
	 */
	private static boolean isPossibleURL(String sUrl) {

		Matcher urlmatcher = CommandLauncher.pUrlPattern.matcher(sUrl);
		if (urlmatcher.find()) {
			return true;
		}
		return false;
	}

	public CommandLauncher() {
		super();
	}
}
