/* File: AnimationListener.java
 *
 * Contains class AnimationListener
 *
 * Author: Brian Ellis
 */

package edu.cmu.hcii.calo.view.animation;

/**
 * Indicates that the implementing class can receive updates about Animations in progress.
 * 
 * @author Brian Ellis
 * 
 */
public interface AnimationListener {

	/**
	 * Called when a given Animation for which this class is a listener has updated its state. This
	 * method will be called as often as possible while the Animation is running, and at least once
	 * when it has finished. A class can listen to more than one Animation at a time, in which case
	 * it should use the parameter to this method to determine which Animation has updated.
	 * 
	 * @param a the Animation that has updated
	 */
	public void animationDidUpdate(Animation a);

}
