/* File: TaskFilter.java
 *
 * Contains class TaskFilter
 *
 * Author: Brian Ellis
 */

package edu.cmu.hcii.calo.view.task.support;

import edu.cmu.hcii.calo.model.Task;

/**
 * A functor that defines which tasks should be shown in a TaskSubpaneView.
 * 
 * @author Brian Ellis
 */
public abstract class TaskFilter {

	/**
	 * The filter function to be called on each task that might be added to a
	 * subpane view. If this returns \c true, the given task will be shown in
	 * the maximized view of the subpane view; otherwise, it will not.
	 * 
	 * @param t
	 *            the task to consider
	 * @return \c true if the task should be shown, \c false otherwise
	 */
	public abstract boolean shouldShowTask(Task t);

}
