package edu.cmu.relativelayout.equation;

import java.util.HashMap;

/**
 * This class is the type for variables in equations
 *
 * @author purple, phoenix
 * @version $Rev$
 */
public class Variable {
	
	private static HashMap<String, Variable> map = new HashMap<String, Variable>();
	
	private String name;
	
	protected Variable(String name) {
		this.name = name;
	}
	
	public String getName() {
		return this.name;
	}
	
	@Override
	public String toString() {
		return this.getName();
	}
	
	public static Variable get(String name)
	{
		if (Variable.map.containsKey(name)) {
			return Variable.map.get(name);
		} else {
			Variable v = new Variable(name);
			Variable.map.put(name, v);
			return v;	
		}
	}

	/**
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object theObj) {
		if (!(theObj instanceof Variable)) {
			System.err.println("Tried to compare two objects of different types.");
			return false;
		}
		return this.name.equals(((Variable)theObj).name); // TODO Auto-generated method stub
	}

	/**
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		return this.name.hashCode(); // TODO Auto-generated method stub
	}
}

